<?php
header("Content-Type: text/html; charset=utf-8");

    /**
     * 合同签署服务示例
     */
    require_once(dirname(__FILE__) . '/' . '../Util.php');

    $sdkClient = Util::getSDk();

//    testContractAudit($sdkClient);

//    testCompanysign($sdkClient);

//    testLpSign($sdkClient);

//    testContractPage($sdkClient);

    testContractViewPage($sdkClient);

    /**
     * 审批合同
     * @param $sdkClient
     * @return mixed
     */
    function testContractAudit(SDKClient $sdkClient){
        $contractAuditRequest = new ContractAuditRequest();
        $contractAuditRequest->setContractId('2591901769294914279');

        $contractAuditRequest->setPass(true);
        $contractAuditRequest->setComment('同意');
        $result = $sdkClient->service($contractAuditRequest);
        print_r($result);
        return $result;
    }

    /**
     * 公司公章签署
     * @param $sdkClient
     * @return mixed
     */
    function testCompanysign(SDKClient $sdkClient){
        $contractCompanySignRequest = new ContractCompanySignRequest();
        $contractCompanySignRequest->setContractId('2590804900506210559');
        $contractCompanySignRequest->setBizId("123456");
        /**公章签署**/
        $stamper1 = new Stamper();
        $stamper1->setType('COMPANY');
        $stamper1->setDocumentId('2590805031263637783');
        $stamper1->setSealId('2555244623418466517');
        $stamper1->setKeyword('劳动');
        $stamper1->setKeywordIndex('2');
        $stamper1->setOffsetX('0.2');
        $stamper1->setOffsetY('-0.2');
        /**时间戳签署**/
        $stamper2 = new Stamper();
        $stamper2->setType('TIMESTAMP');
        $stamper2->setDocumentId('2590805031263637783');
        $stamper2->setSealId('2555244623418466517');
        $stamper2->setPage('1');
        $stamper2->setOffsetX('0.5');
        $stamper2->setOffsetY('0.5');
        /**骑缝章签署**/
        $stamper3 = new Stamper();
        $stamper3->setType('ACROSS_PAGE');
        $stamper3->setDocumentId('2590805031263637783');
        $stamper3->setSealId('2555244623418466517');
        $stamper3->setOffsetY('0.5');
        $stampers = array();
        array_push($stampers, $stamper1);
        array_push($stampers, $stamper2);
        array_push($stampers, $stamper3);
        $contractCompanySignRequest->setStampers($stampers);
        $result = $sdkClient->service($contractCompanySignRequest);
        print_r($result);
        return $result;
    }

    /**
     * 法人签署
     * @param SDKClient $sdkClient
     * @return mixed|null|string
     */
    function testLpSign(SDKClient $sdkClient){
        $contractLpSignRequest = new ContractLpSignRequest();
        $contractLpSignRequest->setContractId('2590804900506210559');
        $contractLpSignRequest->setBizId("1111111");
        /**关键字定位**/
        $stamper1 = new Stamper();
        $stamper1->setType('LP');
        $stamper1->setDocumentId('2590805031263637783');
        $stamper1->setKeyword('劳动');
        $stamper1->setKeywordIndex('2');
        $stamper1->setOffsetX('0.1');
        $stamper1->setOffsetY('-0.1');
        /**坐标定位**/
        $stamper2 = new Stamper();
        $stamper2->setType('LP');
        $stamper2->setDocumentId('2590805031263637783');
        $stamper2->setPage('1');
        $stamper2->setOffsetX('0.5');
        $stamper2->setOffsetY('0.5');

        $stampers = array();
        array_push($stampers, $stamper1);
        array_push($stampers, $stamper2);

        $contractLpSignRequest->setStampers($stampers);
        $result = $sdkClient->service($contractLpSignRequest);
        print_r($result);
        return $result;
    }

    /**
     * 合同签署页面
     * @param SDKClient $sdkClient
     * @return mixed|null|string
     */
    function testContractPage(SDKClient $sdkClient){
        $contractPageRequest = new ContractPageRequest();
        $contractPageRequest->setContractId('2590804900506210559');
        $contractPageRequest->setBizId("123456789");

        $user = new User();
        $user->setContact("18435186216");
        $user->setContactType("MOBILE");

        $contractPageRequest->setUser($user);
        $result = $sdkClient->service($contractPageRequest);
        print_r($result);
        return $result;
    }

    /**
     * @param SDKClient $sdkClient
     */
    function testContractViewPage(SDKClient $sdkClient){
        $contractViewPageRequest = new ContractViewPageRequest();
        $contractViewPageRequest->setContractId('2605319579798344136');
        $contractViewPageRequest->setBizId('12345678');
        $result = $sdkClient->service($contractViewPageRequest);
        print_r($result);
    }