<?php
header("Content-Type: text/html; charset=utf-8");

    /**
     * 合同接口测试
     */
    require_once(dirname(__FILE__) . '/' . '../Util.php');

    $sdkClient = Util::getSDk();

//    testDraftContract($sdkClient);

//    testDocumentAddByFile($sdkClient);

//    testDocumentAddByTemplate($sdkClient);

//    testSendContract($sdkClient);

//    testSignatoryAdd($sdkClient);

//    testContractDetail($sdkClient);

//    testContractNotify($sdkClient);

//    testContractInvalid($sdkClient);

    /**
     * 创建合同草稿
     */
    function testDraftContract(SDKClient $sdkClient){
        /** 合同基本信息 */
        $contract = new Contract();
//        $contract->setId("");
        $contract->setBizId("123123");
        $contract->setSubject("V2合同");
        $contract->setDescription("合同描述");
        $contract->setSn("123321");
        $contract->setExpireTime("2019-07-30 00:00:00");
        $contract->setOrdinal(true);
        $contract->setSend(false);

        $category = new Category();
        $category->setName("V2");
        $contract->setCategory($category);

        $creator = new User();
        $creator->setContact("18435186216");
        $creator->setContactType("MOBILE");
        $contract->setCreator($creator);

        /**公司签署方**/
        $companySignatory = new Signatory();
        $companySignatory->setTenantType("COMPANY");
        $companySignatory->setTenantName("思晨教育");
        $companySignatory->setSerialNo(1);

        $receiver = new User();
        $receiver->setContact("18435186216");
        $receiver->setContactType("MOBILE");

        $companySignatory->setReceiver($receiver);

        /**公章签署动作**/
        $companyAction = new Action();
        $companyAction->setType("COMPANY");
        $companyAction->setName("公章签署动作");
        $companyAction->setSerialNo(1);
        /**公章签署操作人**/
        $companyOperator = new User();
        $companyOperator->setContact("18435186216");
        $companyOperator->setContactType("MOBILE");

        $companyOperators = array();
        array_push($companyOperators, $companyOperator);
        $companyAction->setOperators($companyOperators);

        /**经办人签字动作**/
        $operatorAction = new Action();
        $operatorAction->setType("OPERATOR");
        $operatorAction->setName("经办人签字动作");
        $operatorAction->setSerialNo(2);

        /**经办人签字操作人**/
        $operatorOperator = new User();
        $operatorOperator->setContact("18435186216");
        $operatorOperator->setContactType("MOBILE");

        $operatorOperators = array();
        array_push($operatorOperators, $operatorOperator);
        $operatorAction->setOperators($operatorOperators);

        /**审批动作**/
        $auditAction = new Action();
        $auditAction->setType("AUDIT");
        $auditAction->setName("审批动作");
        $auditAction->setSerialNo(3);
        /**审批操作人**/
        $auditOperator = new User();
        $auditOperator->setContact("18435186216");
        $auditOperator->setContactType("MOBILE");

        $auditOperators = array();
        array_push($auditOperators, $auditOperator);
        $auditAction->setOperators($auditOperators);

        /**法人签署动作**/
        $lpAction = new Action();
        $lpAction->setType("LP");
        $lpAction->setName("法人签署动作");
        $lpAction->setSerialNo(4);

        $actions = array();
        /**公司签署方设置公章签署动作**/
        array_push($actions, $companyAction);
        /**公司签署方设置经办人签字动作**/
        array_push($actions, $operatorAction);
        /**公司签署方设置审批动作**/
        array_push($actions, $auditAction);
        /**公司签署方设置审批动作**/
        array_push($actions, $lpAction);

        $companySignatory->setActions($actions);

        /**个人签署方**/
        $personalSignatory = new Signatory();
        $personalSignatory->setTenantType("PERSONAL");
        $personalSignatory->setTenantName("吉哲");
        $personalSignatory->setSerialNo(2);

        $receiver = new User();
        $receiver->setContact("18435186216");
        $receiver->setContactType("MOBILE");

        $personalSignatory->setReceiver($receiver);

        /**所有签署方**/
        $signatories = array();
        array_push($signatories, $companySignatory);
        array_push($signatories, $personalSignatory);

        $contract->setSignatories($signatories);

        $baseRequest = new ContractDraftRequest($contract);

        $result = $sdkClient->service($baseRequest);
        print_r($result);
    }

    /**
     * 根据文件添加文档
     * @param SDKClient $sdkClient
     * @return mixed|null|string
     */
    function testDocumentAddByFile(SDKClient $sdkClient){

        $documentAddByFileRequest = new DocumentAddByFileRequest();
        $documentAddByFileRequest->setContractId('2590804900506210559');
        $documentAddByFileRequest->setBizId("123456");

        $file_path = "C:/Users/QYS/Desktop/Test/劳动合同_带参数.docx";

        $file_path = iconv("UTF-8", "GBK", realpath($file_path));

        $file = new \CURLFile($file_path);

        $documentAddByFileRequest->setFile($file);
        $documentAddByFileRequest->setFileSuffix('docx');
        $documentAddByFileRequest->setTitle('V2添加文档1');
        $result = $sdkClient->service($documentAddByFileRequest);
        print_r($result);
        return $result;
    }

    /**
     * 根据模板添加文档
     * @param SDKClient $sdkClient
     * @return mixed|null|string
     */
    function testDocumentAddByTemplate(SDKClient $sdkClient){

        $documentAddByTemplateRequest = new DocumentAddByTemplateRequest();
        $documentAddByTemplateRequest->setContractId('2590758386643734529');
        $documentAddByTemplateRequest->setBizId("1111111");
        $documentAddByTemplateRequest->setTitle('V2添加模板文档');
        $documentAddByTemplateRequest->setTemplateId('2558597440364655396');
        /**填写模板参数**/
        $templateParam1 = new TemplateParam();
        $templateParam1->setName("乙方姓名");
        $templateParam1->setValue("张三");

        $templateParams = array();
        array_push($templateParams, $templateParam1);

        $documentAddByTemplateRequest->setTemplateParams($templateParams);
        $result = $sdkClient->service($documentAddByTemplateRequest);
        print_r($result);
        return $result;
    }

    /**
     * 发起合同
     * @param SDKClient $sdkClient
     * @return mixed|null|string
     */
    function testSendContract(SDKClient $sdkClient){

        $contractSendRequest = new ContractSendRequest();
        $contractSendRequest->setContractId('2590804900506210559');
        $contractSendRequest->setBizId("1111111");

        $stamper1 = new Stamper();
        $stamper1->setType('COMPANY');
        $stamper1->setActionId('2590758390800289796');
        $stamper1->setDocumentId('2590764888637018192');
        $stamper1->setSealId('2555244623418466517');
        $stamper1->setKeyword('劳动');
        $stamper1->setKeywordIndex('2');
        $stamper1->setOffsetX('0.1');
        $stamper1->setOffsetY('-0.1');

        $stamper2 = new Stamper();
        $stamper2->setType('COMPANY');
        $stamper2->setActionId('2590758390800289796');
        $stamper2->setDocumentId('2590762507098624044');
        $stamper2->setSealId('2555244623418466517');
        $stamper2->setPage('1');
        $stamper2->setOffsetX('0.5');
        $stamper2->setOffsetY('0.5');

        $stampers = array();
        array_push($stampers, $stamper1);
        array_push($stampers, $stamper2);

//        $contractSendRequest->setStampers($stampers);
        $result = $sdkClient->service($contractSendRequest);
        print_r($result);
        return $result;
    }

    /**
     * 添加签署方
     * @param SDKClient $sdkClient
     * @return mixed|null|string
     */
    function testSignatoryAdd(SDKClient $sdkClient){
        $signatoryAddRequest = new SignatoryAddRequest();
        $signatoryAddRequest->setContractId('2589678690921123947');
        $signatoryAddRequest->setBizId('123456789');

        /**个人签署方**/
        $personalSignatory = new Signatory();
        $personalSignatory->setTenantType("PERSONAL");
        $personalSignatory->setTenantName("吉哲");

        $receiver = new User();
        $receiver->setContact("18435186216");
        $receiver->setContactType("MOBILE");
        $personalSignatory->setReceiver($receiver);

        $signatoryAddRequest->setSignatory($personalSignatory);
        $result = $sdkClient->service($signatoryAddRequest);
        print_r($result);
        return $result;
    }

    /**
     * 合同详情查询
     * @param SDKClient $sdkClient
     */
    function testContractDetail(SDKClient $sdkClient){
        $contractDetailRequest = new ContractDetailRequest();
        $contractDetailRequest->setContractId('2590804900506210559');
        $result = $sdkClient->service($contractDetailRequest);
        print_r($result);
    }

    /**
     * 合同催签
     * @param SDKClient $sdkClient
     */
    function testContractNotify(SDKClient $sdkClient){
        $contractNoticeRequest = new ContractNoticeRequest();
        $contractNoticeRequest->setContractId('2591540368898105360');
        $contractNoticeRequest->setBizId('123456789');
        $contractNoticeRequest->setSignatoryId('2591540371314024472');
        $result = $sdkClient->service($contractNoticeRequest);
        print_r($result);
    }

    /**
     * 合同作废
     * @param SDKClient $sdkClient
     */
    function testContractInvalid(SDKClient $sdkClient){
        $contractInvalidRequest = new ContractInvalidRequest();
        $contractInvalidRequest->setContractId('2590804900506210559');
        $contractInvalidRequest->setBizId('123456789');
        $contractInvalidRequest->setSealId('2589678690921123947');
        $contractInvalidRequest->setReason('作废');
        $contractInvalidRequest->setDeleteDoc(false);
        $result = $sdkClient->service($contractInvalidRequest);
        print_r($result);
    }